/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: e_tmrt.c,v 1.2 1997/09/25 17:16:32 ae59 Exp $ */
/*
$Log: e_tmrt.c,v $
 * Revision 1.2  1997/09/25  17:16:32  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:22:16  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : e_tmrt.c                              */
/*                                                              */
/*      Entry           : void e_tmrt(e_argc,e_argv,print)      */
/*                        int e_argc;                           */
/*                        va_list e_argv;                       */
/*                        a_bool print;                         */
/*                                                              */
/*      Arguments       : e_argc - number of arguments          */
/*                        e_argv - reference to arguments       */
/*                        print - leading messages printed      */
/*                                                              */
/*      Description     : Print leading messages, but do not    */
/*                        print argument list.                  */
/*                                                              */
/*      Note            : e_argc must be even.                  */
/*                        e_argv is a list of pairs representing*/
/*                        integer values for the data type      */
/*                        specification and pointers to the     */
/*                        objects.                              */
/*                        Displaying stops if one result        */
/*                        argument is detected or the list ends.*/
/*                                                              */
/*      Date            : 1993-02-16                            */
/*      1993-02-16 : update from Dr. Cordes                     */
/*      1992-12-26 : E_TLNG case added                          */
/*      1992-12-05 : consider E_TMSG in switch-statement        */
/*      1991-02-13 : new data characterization E_TSTG           */
/*      1990-12-13 : ultraprecision actually not used           */
/*      1990-12-12 : in case of result (char *) must be popped  */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
extern char *e_head;
extern f_text f_errr;
extern a_VOID e_rptr;
extern int e_rtyp;
#endif

#ifdef LINT_ARGS
local void e_tmrt(int e_argc,va_list e_argv,a_bool print)
#else
local void e_tmrt(e_argc,e_argv,print)
int e_argc;
va_list e_argv;
a_bool print;
#endif
        {
        int i,type;    /* !!! must be int !!! */

        e_rtyp = 0;
        e_rptr = NULL;

        for (i=0;i<e_argc;)
           {
           /* possible pointer allignment problems              */
           type = e_ref(int);

           /* Process message */
           if (type==E_TMSG && i==0)
              {
              /* possible pointer allignment problems           */
              type = e_ref(int);
              if (print) e_tmsg(type);
              e_argc -= 2;
              continue;
              }

           switch (type & ~(E_TRES+E_TMSG))
              {
              case E_TCHR:
                 /* possible pointer allignment problems        */
                 e_rptr = e_ref(char *);
                 break;
              case E_TDBL:
                 /* possible pointer allignment problems        */
                 e_rptr = (char *)e_ref(a_real *);
                 break;
              case E_TLNG:
                 /* possible pointer allignment problems        */
                 e_rptr = (char *)e_ref(a_long *);
                 break;
              case E_TDTP:
                 /* possible pointer allignment problems        */
                 e_rptr = (char *)e_ref(dotprecision *);
                 break;
              case E_TINT:
                 /* possible pointer allignment problems        */
                 e_rptr = (char *)e_ref(a_intg *);
                 break;
              case E_TMLT:
                 /* possible pointer allignment problems        */
                 e_rptr = (char *)e_ref(multiprecision *);
                 break;
              case E_TSTR:
                 /* possible pointer allignment problems        */
                 e_rptr = e_ref(char *);
                 break;
/*
              case E_TULT:
                 e_rptr = e_ref(ultraprecision *);
                 break;
*/
              case E_TSTG:
                 /* possible pointer allignment problems        */
                 e_rptr = (char *)e_ref(s_trng *);
                 break;
              }
           i += 2;

           /* Display stops if result */
           if ((type & E_TRES)!=0)
              {
              e_rtyp = type ^ E_TRES;
              return;
              }
           }

        return;
        }
